/* The file is saved in UTF-8 codepage.
 * Check: «Stereotype», Section mark-§, Copyright-©, Alpha-α, Beta-β, Smile-☺
 */
package awt_edt;

import java.awt.EventQueue;



public final class Tst_1
{
    /** Atribut odkazující na jedinou existující instanci této třídy -
     *  inicializujeme jej hned v deklaraci. */
    private static final Tst_1 singleton = new Tst_1();

    /** Následující atribut zastupuje všechny atributy,
     *  které by se měly inicializovat v kódu zařazeném
     *  do fronty událostí. */
    private Object xxx;


    public static Tst_1 getInstance()
    {
        //Oslovím jeden z atributů jedináčka - např. aby se zobrazil
        singleton.xxx.toString();
        return singleton;
    }


    private Tst_1()
    {
        //Při konstrukci instance je třeba provést několik operací,
        //které by se měly správě vykonávat ve frontě událostí.
        //Připravím si proto objekt s metodou, která vše vykoná.
        Runnable runnable = new Runnable()
        {
            @Override
            public void run() {
                //Akci definuji pro přehlednost v separátní metodě
                initializaton();
            }
        };
        //A zařadím objekt do fronty událostí, aby se ve vhodnou chvíli vykonal
        EventQueue.invokeLater(runnable);
    }


    public void initializaton()
    {
        //Následující příkaz zastupuje všechny akce,
        //které je vhodné vykoávat řízeně ve frontě událostí
        xxx  = new Object();
     }



    /** Třída, z níž se bude volat tovární metoda getInstance().
     *  Metodu volám z jiné třídy, aby se jasně oddělilo zavedení třídy
     *  od jejího použití.
     *  Třída je definována jako interní jenom proto,
     *  abych mohl mít metodu main ve stejném souboru jako testovaný kód.
     *  Protože je třída definována jako statická, tak je pak jedno,
     *  je-li uvnitř třídy a nebo někde zcela jinde.
     */
    public static class Main
    {
        public static void testMain()
        {
            Tst_1 instance = Tst_1.getInstance();
        }
        /** @param args Command line arguments - not used. */
        public static void main(String[] args)  {
            testMain();
        }
    }
}
