/* The file is saved in UTF-8 codepage.
 * Check: «Stereotype», Section mark-§, Copyright-©, Alpha-α, Beta-β, Smile-☺
 */
package awt_edt;

import java.awt.EventQueue;

import static dbg.ThreadMessages.*;


public final class Tst_1A
{
    static {
        msgS("<clinit> # Tst_1");
    }

    private static final Tst_1A singleton = new Tst_1A();

    private Object xxx;


    public static Tst_1A getInstance()
    {
        msgS("getInstance(): singleton=" + singleton);
        try {
              msg("getInstance(): singleton.xxx=" +
                  singleton.xxx.toString());
        }
        catch (Exception e) {
            msg("getInstance(): crashed");
            e.printStackTrace(System.out);
        }
        msgF("getInstance(): singleton=" + singleton);
        return singleton;
    }


    private Tst_1A()
    {
        msgS("Constructor");
        Runnable runnable = new Runnable()
        {
            @Override
            public void run() {
                msgS("invokeLater - run()");
                initializaton();     //### Critical point ###
                msgF("invokeLater - run()");
            }
        };
        EventQueue.invokeLater(runnable);
        msg ("Constructor: Start to sleep");
        pause(500);
        msgF("Constructor: this=" + this);
    }


    private void initializaton()
    {
        msgS("initializaton(): this=" + this);
        xxx  = new Object();
        msgF("initializaton(): this=" + this);
     }


    @Override
    public String toString()
    {
        return "Tst_1{" + "xxx=" + xxx + '}';
    }


    private static class Main
    {
        public static void testMain()
        {
            msgS("testMain()");
            Tst_1A instance = Tst_1A.getInstance();
            msgF("testMain()");
        }
        /** @param args Command line arguments - not used. */
        public static void main(String[] args)  {
            msgS("main() # Tst_1.Main");
            testMain();
            msgF("main() # Tst_1.Main");
        }
    }

    static {
        msg ("<clinit>: Before next sleep, singleton=" + singleton);
        pause(500);
        msgF("<clinit> # Tst_1: singleton=" + singleton);
    }
}
