/* The file is saved in UTF-8 codepage.
 * Check: «Stereotype», Section mark-§, Copyright-©, Alpha-α, Beta-β, Smile-☺
 */
package awt_edt;

import java.awt.EventQueue;

import static dbg.ThreadMessages.*;


public final class Tst_2B
{
    static {
        msgS("<clinit> # Tst_2A");
    }

    private static Tst_2B singleton;

    private volatile Object xxx;


    public static Tst_2B getInstance()
    {
        msgS("getInstance(): singleton=" + singleton);
        if (singleton == null) {
            synchronized(Tst_2B.class) {
                if (singleton == null) {
                    msg("getInstance(): call constructor");
                    singleton = new Tst_2B();
                    msg("getInstance(): singleton=" + singleton);
                }
            }
        }
        msgF("getInstance(): singleton=" + singleton);
        return singleton;
    }


    private Tst_2B()
    {
        msgS("Constructor");
        Runnable runnable = new Runnable()
        {
            @Override
            public void run() {
                msgS("invokeAndWait - run()");
                initializaton();
                msgF("invokeAndWait - run()");
            }
        };
        Thread thread2 = new Thread(runnable, "Thread_2");
        thread2.start();
        try {
            thread2.join();
        } catch (InterruptedException ex) {
            //Ošetření přerušení
        }
        msgF("Constructor: this=" + this);
    }


    private void initializaton()
    {
        msgS("initializaton(): this=" + this);
        xxx  = new Object();
        msgF("initializaton(): this=" + this);
     }


    @Override
    public String toString()
    {
        return "CM_3_nonAWT{" + "xxx=" + xxx + '}';
    }


    private static class Main
    {
        public static void testMain()
        {
            msgS("testMain()");
            Tst_2B instance = Tst_2B.getInstance();
            msgF("testMain()");
        }
        /** @param args Command line arguments - not used. */
        public static void main(String[] args)  {
            msgS("main() # Tst_2A.Main");
            testMain();
            msgF("main() # Tst_2A.Main");
        }
    }

    static {
        msgF("<clinit> # Tst_2A: singleton=" + singleton);
    }
}